<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <groupId>br.jus.tre_pa</groupId>
    <artifactId>${projectName}</artifactId>
    <version>0.0.1-SNAPSHOT</version>
    <packaging>jar</packaging>
    <parent>
        <groupId>org.springframework.boot</groupId>
        <artifactId>spring-boot-starter-parent</artifactId>
        <version>2.7.14</version>
        <relativePath/> <!-- lookup parent from repository -->
    </parent>
    <name>${projectName}</name>
    <description>${projectName}</description>
    <properties>
        <docker.registry>git.tre-pa.jus.br:4567</docker.registry>
        <server.servlet.context-path>/${projectName}</server.servlet.context-path>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <project.reporting.outputEncoding>UTF-8</project.reporting.outputEncoding>
        <java.version>17</java.version>
        <keycloak.version>13.0.1</keycloak.version>
        <keycloak.realm>TRE-PA</keycloak.realm>
        <git-commit-id-plugin.version>4.9.10</git-commit-id-plugin.version>
        <oracle.jdbc.version>12.2.0.1</oracle.jdbc.version>
        <keycloak-plugin.version>1.1.1</keycloak-plugin.version>
        <modelmapper.version>3.1.1</modelmapper.version>
    </properties>
    <dependencies>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-data-jpa</artifactId>
        </dependency>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-web</artifactId>
        </dependency>
<#--        <dependency>-->
<#--            <groupId>org.springframework.boot</groupId>-->
<#--            <artifactId>spring-boot-devtools</artifactId>-->
<#--            <optional>true</optional>-->
<#--        </dependency>-->
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-actuator</artifactId>
        </dependency>
        <dependency>
            <groupId>org.hibernate</groupId>
            <artifactId>hibernate-envers</artifactId>
            <version>${r'${hibernate.version}'}</version>
        </dependency>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-test</artifactId>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-validation</artifactId>
        </dependency>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-configuration-processor</artifactId>
            <optional>true</optional>
        </dependency>
        <dependency>
            <groupId>com.oracle.database.jdbc</groupId>
            <artifactId>ojdbc8</artifactId>
            <version>${r'${oracle.jdbc.version}'}</version>
        </dependency>
        <dependency>
            <groupId>org.projectlombok</groupId>
            <artifactId>lombok</artifactId>
            <optional>true</optional>
        </dependency>
        <dependency>
            <groupId>org.flywaydb</groupId>
            <artifactId>flyway-core</artifactId>
            <version>4.2.0</version>
        </dependency>
        <dependency>
            <groupId>org.modelmapper</groupId>
            <artifactId>modelmapper</artifactId>
            <version>${r'${modelmapper.version}'}</version>
        </dependency>
        <dependency>
            <groupId>javax.validation</groupId>
            <artifactId>validation-api</artifactId>
            <version>2.0.1.Final</version>
        </dependency>
        <dependency>
            <groupId>com.github.tennaito</groupId>
            <artifactId>rsql-jpa</artifactId>
            <version>2.0.2</version>
        </dependency>
        <dependency>
            <groupId>org.apache.commons</groupId>
            <artifactId>commons-lang3</artifactId>
        </dependency>
        <dependency>
            <groupId>org.keycloak</groupId>
            <artifactId>keycloak-spring-boot-starter</artifactId>
            <version>${r'${keycloak.version}'}</version>
        </dependency>
        <dependency>
            <groupId>org.codehaus.mojo</groupId>
            <artifactId>sonar-maven-plugin</artifactId>
            <version>3.10.0.2594</version>
        </dependency>
        <dependency>
            <groupId>io.micrometer</groupId>
            <artifactId>micrometer-registry-prometheus</artifactId>
            <scope>runtime</scope>
        </dependency>
        <dependency>
            <groupId>com.fasterxml.jackson.dataformat</groupId>
            <artifactId>jackson-dataformat-csv</artifactId>
        </dependency>
    </dependencies>
    <pluginRepositories>
        <pluginRepository>
            <id>gitlab-maven</id>
            <url>https://gitlab.com/api/v4/projects/39041371/packages/maven</url>
        </pluginRepository>
    </pluginRepositories>
    <build>
        <finalName>${r'${project.name}-${project.version}.${git.commit.id.abbrev}'}</finalName>
        <resources>
            <resource>
                <directory>src/main/resources</directory>
                <filtering>true</filtering>
            </resource>
        </resources>
        <plugins>
            <plugin>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-maven-plugin</artifactId>
                <executions>
                    <execution>
                        <goals>
                            <goal>build-info</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>com.github.eirslett</groupId>
                <artifactId>frontend-maven-plugin</artifactId>
                <version>1.13.4</version>
                <configuration>
                    <installDirectory>target</installDirectory>
                    <nodeVersion>v18.17.1</nodeVersion>
                    <nodeDownloadRoot>https://nexus.tre-pa.jus.br/repository/nodejs.dist/</nodeDownloadRoot>
                    <npmInheritsProxyConfigFromMaven>false</npmInheritsProxyConfigFromMaven>
                </configuration>
                <executions>
                    <execution>
                        <id>install node and npm</id>
                        <goals>
                            <goal>install-node-and-npm</goal>
                        </goals>
                        <phase>prepare-package</phase>
                    </execution>
                    <execution>
                        <id>npm install</id>
                        <goals>
                            <goal>npm</goal>
                        </goals>
                        <phase>prepare-package</phase>
                    </execution>
                    <execution>
                        <id>npm run build</id>
                        <goals>
                            <goal>npm</goal>
                        </goals>
                        <phase>prepare-package</phase>
                        <configuration>
                            <arguments>run build</arguments>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>pl.project13.maven</groupId>
                <artifactId>git-commit-id-plugin</artifactId>
                <version>${r'${git-commit-id-plugin.version}'}</version>
                <executions>
                    <execution>
                        <phase>validate</phase>
                        <goals>
                            <goal>revision</goal>
                        </goals>
                    </execution>
                </executions>
                <configuration>
                    <failOnNoGitDirectory>false</failOnNoGitDirectory>
                    <failOnUnableToExtractRepoInfo>false</failOnUnableToExtractRepoInfo>
                    <generateGitPropertiesFile>true</generateGitPropertiesFile>
                    <includeOnlyProperties>
                        <includeOnlyProperty>^git.commit.id.abbrev$</includeOnlyProperty>
                        <includeOnlyProperty>^git.commit.id.describe$</includeOnlyProperty>
                        <includeOnlyProperty>^git.branch$</includeOnlyProperty>
                    </includeOnlyProperties>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-site-plugin</artifactId>
                <version>3.7.1</version>
            </plugin>
            <plugin>
                <groupId>com.github.jeluard</groupId>
                <artifactId>plantuml-maven-plugin</artifactId>
                <version>7941</version>
                <configuration>
                    <sourceFiles>
                        <directory>${r'${basedir}'}</directory>
                        <includes>
                            <include>src/site/diagrams/**/*.plantuml</include>
                        </includes>
                    </sourceFiles>
                    <outputDirectory>${r'${basedir}/src/site/resources/images'}</outputDirectory>
                </configuration>
                <executions>
                    <execution>
                        <phase>pre-site</phase>
                        <goals>
                            <goal>generate</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-pdf-plugin</artifactId>
                <version>1.6.1</version>
                <executions>
                    <execution>
                        <id>pdf</id>
                        <phase>site</phase>
                        <goals>
                            <goal>pdf</goal>
                        </goals>
                        <configuration>
                            <outputDirectory>${r'${project.reporting.outputDirectory}'}</outputDirectory>
                            <includeReports>false</includeReports>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>io.fabric8</groupId>
                <artifactId>docker-maven-plugin</artifactId>
                <version>0.40.2</version>
                <configuration>
                    <images>
                        <image>
                            <name>
                                ${r'${env.CI_REGISTRY}/${CI_PROJECT_NAMESPACE}/${project.name}:${project.version}.${git.commit.id.abbrev}'}
                            </name>
                            <build>
                                <contextDir>${r'${project.basedir}'}</contextDir>
                                <network>host</network>
                                <filter>@</filter>
                            </build>
                        </image>
                    </images>
                    <authConfig>
                        <username>${r'${env.CI_REGISTRY_USER}'}</username>
                        <password>${r'${env.CI_REGISTRY_PASSWORD}'}</password>
                    </authConfig>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.eclipse.jkube</groupId>
                <artifactId>kubernetes-maven-plugin</artifactId>
                <version>1.9.1</version>
                <configuration>
                    <resourceDir>src/main/resources/jkube</resourceDir>
                    <images>
                        <image>
                            <name>${r'${env.CI_REGISTRY}/${env.CI_PROJECT_NAMESPACE}/${project.name}:${project.version}.${git.commit.id.abbrev}'}</name>
                            <registry>${r'${env.CI_REGISTRY}'}</registry>
                        </image>
                    </images>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-enforcer-plugin</artifactId>
                <version>3.1.0</version>
                <configuration>
                    <rules>
                        <requireEnvironmentVariable>
                            <variableName>SPRING_DATASOURCE_URL</variableName>
                        </requireEnvironmentVariable>
                        <requireEnvironmentVariable>
                            <variableName>SPRING_DATASOURCE_USERNAME</variableName>
                        </requireEnvironmentVariable>
                        <requireEnvironmentVariable>
                            <variableName>SPRING_DATASOURCE_PASSWORD</variableName>
                        </requireEnvironmentVariable>
                        <requireEnvironmentVariable>
                            <variableName>KEYCLOAK_AUTH_SERVER_URL</variableName>
                        </requireEnvironmentVariable>
                        <requireEnvironmentVariable>
                            <variableName>KEYCLOAK_CONFIG_BASE_URL</variableName>
                        </requireEnvironmentVariable>
                        <requireEnvironmentVariable>
                            <variableName>KEYCLOAK_CONFIG_VALID_REDIRECT_URL</variableName>
                        </requireEnvironmentVariable>
                        <requireEnvironmentVariable>
                            <variableName>KEYCLOAK_CREDENTIALS_SECRET</variableName>
                        </requireEnvironmentVariable>
                        <requireEnvironmentVariable>
                            <variableName>LOGGING_LEVEL</variableName>
                        </requireEnvironmentVariable>
                    </rules>
                    <fail>true</fail>
                </configuration>
            </plugin>
        </plugins>
    </build>
    <reporting>
        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-project-info-reports-plugin</artifactId>
                <version>2.9</version>
                <reportSets>
                    <reportSet>
                        <configuration>
                            <skip>true</skip>
                        </configuration>
                    </reportSet>
                </reportSets>
            </plugin>
            <!-- any further custom report here -->
        </plugins>
    </reporting>

    <profiles>
        <profile>
            <id>local</id>
            <activation>
                <activeByDefault>true</activeByDefault>
            </activation>
            <build>
                <plugins>
                    <plugin>
                        <groupId>xtool.plugins</groupId>
                        <artifactId>keycloak-plugin</artifactId>
                        <version>${r'${keycloak-plugin.version}'}</version>
                        <executions>
                            <execution>
                                <id>apply</id>
                                <goals>
                                    <goal>apply</goal>
                                </goals>
                                <phase>compile</phase>
                                <configuration>
                                    <realm>TRE-PA</realm>
                                    <properties>
                                        <keycloak.client.secret>f541e548-ff50-4c97-928d-f296fcd7be9c
                                        </keycloak.client.secret>
                                    </properties>
                                </configuration>
                            </execution>
                            <execution>
                                <id>update-client</id>
                                <goals>
                                    <goal>update-client</goal>
                                </goals>
                                <phase>compile</phase>
                                <configuration>
                                    <realm>TRE-PA</realm>
                                    <clientId>${projectName}-frontend</clientId>
                                    <redirectUris>
                                        <param>
                                        http://localhost:4200/*</param>
                                        <param>
                                        /${projectName}-frontend/*</param>
                                    </redirectUris>
                                    <webOrigins>
                                        <param>
                                        *</param>
                                    </webOrigins>
                                </configuration>
                            </execution>
                            <execution>
                                <id>gen-enforcers</id>
                                <goals>
                                    <goal>gen-enforcer</goal>
                                </goals>
                                <phase>compile</phase>
                            </execution>
                        </executions>
                    </plugin>
                </plugins>
            </build>
        </profile>
        <profile>
            <id>dev</id>
            <build>
                <plugins>
                    <plugin>
                        <groupId>org.apache.maven.plugins</groupId>
                        <artifactId>maven-enforcer-plugin</artifactId>
                        <version>3.1.0</version>
                        <configuration>
                            <rules>
                                <requireEnvironmentVariable>
                                    <variableName>${r'DEV_KEYCLOAK_CLIENT_CREATOR_USERNAME'}</variableName>
                                </requireEnvironmentVariable>
                                <requireEnvironmentVariable>
                                    <variableName>${r'DEV_KEYCLOAK_CLIENT_CREATOR_PASSWORD'}</variableName>
                                </requireEnvironmentVariable>
                                <requireEnvironmentVariable>
                                    <variableName>${r'KEYCLOAK_AUTH_SERVER_URL'}</variableName>
                                </requireEnvironmentVariable>
                            </rules>
                            <fail>true</fail>
                        </configuration>
                    </plugin>
                    <plugin>
                        <groupId>xtool.plugins</groupId>
                        <artifactId>keycloak-plugin</artifactId>
                        <version>${r'${keycloak-plugin.version}'}</version>
                        <configuration>
                            <user>${r'${env.DEV_KEYCLOAK_CLIENT_CREATOR_USERNAME}'}</user>
                            <password>${r'${env.DEV_KEYCLOAK_CLIENT_CREATOR_PASSWORD}'}</password>
                            <url>${r'${env.KEYCLOAK_AUTH_SERVER_URL}'}</url>
                            <realm>TRE-PA</realm>
                            <properties>
                                <keycloak.client.secret>${r'${env.KEYCLOAK_CREDENTIALS_SECRET}'}</keycloak.client.secret>
                            </properties>
                        </configuration>
                    </plugin>
                </plugins>
            </build>
        </profile>
        <profile>
            <id>prod</id>
            <build>
                <plugins>
                    <plugin>
                        <groupId>org.apache.maven.plugins</groupId>
                        <artifactId>maven-enforcer-plugin</artifactId>
                        <version>3.1.0</version>
                        <configuration>
                            <rules>
                                <requireEnvironmentVariable>
                                    <variableName>PROD_KEYCLOAK_CLIENT_CREATOR_USERNAME</variableName>
                                </requireEnvironmentVariable>
                                <requireEnvironmentVariable>
                                    <variableName>PROD_KEYCLOAK_CLIENT_CREATOR_PASSWORD</variableName>
                                </requireEnvironmentVariable>
                                <requireEnvironmentVariable>
                                    <variableName>KEYCLOAK_AUTH_SERVER_URL</variableName>
                                </requireEnvironmentVariable>
                                <requireEnvironmentVariable>
                                    <variableName>KEYCLOAK_CREDENTIALS_SECRET</variableName>
                                </requireEnvironmentVariable>
                            </rules>
                            <fail>true</fail>
                        </configuration>
                    </plugin>
                    <plugin>
                        <groupId>xtool.plugins</groupId>
                        <artifactId>keycloak-plugin</artifactId>
                        <version>${r'${keycloak-plugin.version}'}</version>
                        <configuration>
                            <user>${r'${env.PROD_KEYCLOAK_CLIENT_CREATOR_USERNAME}'}</user>
                            <password>${r'${env.PROD_KEYCLOAK_CLIENT_CREATOR_PASSWORD}'}</password>
                            <url>${r'${env.KEYCLOAK_AUTH_SERVER_URL}'}</url>
                            <realm>TRE-PA</realm>
                            <properties>
                                <keycloak.client.secret>${r'${env.KEYCLOAK_CREDENTIALS_SECRET}'}</keycloak.client.secret>
                            </properties>
                        </configuration>
                    </plugin>
                </plugins>
            </build>
        </profile>
    </profiles>

</project>
